*==============================================================================
* Program:				RIPMAIL.PRG
* Purpose:				Generate contacts from a mailing list folder
* Author:				Ted Roche
* Copyright:			(c) 2002 
* Last revision:		23-July-2002
*==============================================================================

#INCLUDE "MSOutl9.H"

LOCAL lcFolderName
lcFolderName = "ProFox List"
LOCAL lcDestination
lcDestination = "ProFox"

* Get a reference to Outlook
LOCAL loOutlook as Outlook.Application
loOutlook = CREATEOBJECT("Outlook.Application")
loOutlook.GetNamespace("MAPI")

* Navigate to the source folder
LOCAL loInboxFolder as Outlook.MAPIFolder, loFolder as Outlook.MAPIFolder
loInboxFolder = loOutlook.GetNamespace("MAPI").GetDefaultFolder(olFolderInbox)
loFolder = loInboxFolder.Folders(lcFoldername)

** Debugging
*? TRANSFORM(loFolder.Items.Count) + " messages"

* Get a handle to the destination folder
LOCAL loTargetFolder as Outlook.MAPIFolder, ;
      loContactFolder as Outlook.MAPIFolder, ;
      loContact as Outlook.ContactItem 
      
loContactFolder = loOutlook.GetNameSpace("MAPI").GetDefaultFolder(olFolderContacts)

* Test for the existence of a folder like this:
IF TYPE([loContactFolder.Folders(lcDestination)]) = "U"  && undefined - no object
  * Create a new folder with the following line:
  loTargetFolder = loContactFolder.Folders.Add(lcDestination, olFolderContacts)
ELSE  && folder type was defined ("O") so it exists
  * Return to that folder with this line:
  loTargetFolder = loContactFolder.Folders(lcDestination)
ENDIF  && destination folder exists

* Get a reference to the messages collection, and iterate through the messages
LOCAL loMailItems as Outlook.Items, loItem as Outlook.MailItem
loMailItems = loFolder.Items

LOCAL loUtils, MailItem
loUtils = CreateObject("Redemption.MAPIUtils")
* PrSenderEmailAddress = 0x0C1F001E
PrSentRepresentingEmailAddress = 0x0065001E
prSentRepresentingName = 0x0042001E

* Create a local scratch cursor to track mail addresses
CREATE CURSOR ProfoxEmail (cEmail c(128))
INDEX ON UPPER(cEmail) TAG cEmail
LOCAL lcWhoFrom, lcFullName, lcEmailAddress

loItem = loMailitems.GetFirst()
DO WHILE VARTYPE(loItem) = "O"
  * get the sender of the message
  *!*	  lcWhoTo = loItem.SenderName
  *!*	  ? lcWhoTo
  * Unfortunately, for a mailing list, they are all they same. We need 
  * the 'On behalf of' name, and that's not possible to get through
  * 'Simple' MAPI. We used Extended MAPI, via the Outlook Redemption module
  lcFullName = loUtils.HrGetOneProp(loItem.MAPIOBJECT, PrSentRepresentingName )
  lcEmailAddress = loUtils.HrGetOneProp(loItem.MAPIOBJECT, PrSentRepresentingEmailAddress )
  lcWhoFrom = lcFullName + " <" + lcEmailAddress + ">"
              
  IF EmailCheck(lcEmailAddress, .T.) AND ;
     NOT SEEK(UPPER(lcWhoFrom), "ProFoxEmail", "cEmail")  && a new one
    INSERT INTO ProFoxEmail VALUES (lcWhoFrom)
    WAIT WINDOW NOWAIT "Adding " + lcWhoFrom + REPLICATE(".",RECCOUNT("ProFoxEmail")%128)
*!*	    loContact = loTargetFolder.Items.Add(olContactItem)
*!*	    WITH loContact
*!*	      .FullName = lcFullName
*!*	      .Email1Address = lcEmailAddress 
*!*	      .Email1AddressType = "SMTP"
*!*	      .Save()
*!*	    ENDWITH && loContact
  ENDIF

  loItem = loMailItems.GetNext()
ENDDO

WAIT CLEAR 

