*!* EmailCheck.prg
PARAMETERS pcEmail , plCheckDomain
*!*	Verify that an email address has met all requirements,
*!*	and optionally check the domain against a table of legal domains
*!*	pcEmail        - the email address we want to check
*!*	plCheckDomain  - pass .T. to check the domain against table of legal domains

LOCAL lce_mail, llCheckDomain, llReturn

llCheckDomain = IIF(PCOUNT()=2 AND VARTYPE(plCheckDomain)="L", plCheckDomain, .F.)
llReturn   = .F.
lcemail   = IIF( TYPE("pcEmail ")="C", UPPER(ALLTR(pcEmail )), "")

* let's take care of some obvious mistakes
llReturn = ;
  LEFT(UPPER(lcEmail ), 4) # "WWW." ;
  AND NOT EMPTY(lcEmail ) ;
  AND lpBadChars(lcEmail )

* Verify that the e-mail address
*  1) has one @ sign in it.
*  2) has a period in it.
*  3) has a period after the @ sign.
*  4) neither starts nor ends with a period
*  5) has no apostrophe in the domain (OK in the name)

llReturn = llReturn ;
  AND AT("@",lcEmail )>0;
  AND RAT(".",lcEmail )>0 ;
  AND AT("@",lcEmail )<RAT(".",lcEmail ) ;
  AND OCCURS("@", lcEmail ) = 1  ;
  AND LEFT(ALLTRIM(lcEmail ), 1) # "." AND RIGHT(ALLTRIM(lcEmail ), 1) # "." ;
  AND ( RAT("'", lcEmail ) = 0 OR RAT("@", lcEmail ) > RAT("'", lcEmail ) )
  

IF llReturn AND llCheckDomain
  IF !USED("Domains")
    USE domains.DBF SHARED AGAIN IN 0 
  ENDIF
  llReturn = SEEK("." + PADR(JUSTEXT(lcEmail ), 9), "Domains", "Domain")
ENDIF
RETURN llReturn


PROCEDURE lpBadChars
PARAMETERS cCheckThis
cCheckThis = ALLTRIM(cCheckThis)
LOCAL lcBadChars, lReturn
lcBadChars = " []{}`~!#$%^&*()+=?< >,/\;:" + CHR(34)
lReturn = .T.
FOR nThisChar = 1 TO LEN(ALLTRIM(cCheckThis))
  IF SUBSTR(cCheckThis, nThisChar, 1) $ lcBadChars
    lReturn = .F.
    EXIT
  ENDIF
ENDFOR
RETURN lReturn